#line 1 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"

#line 94 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"


#include "smtp_parsers.h"
#include "content_type.h"


#line 11 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
static const int content_type_parser_start = 1;
static const int content_type_parser_first_final = 23;
static const int content_type_parser_error = 0;

static const int content_type_parser_en_balanced_ccontent = 22;
static const int content_type_parser_en_main = 1;


#line 99 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"


gboolean
rspamd_content_disposition_parser (const char *data, size_t len, struct rspamd_content_disposition *cd, rspamd_mempool_t *pool)
{
	const char *p = data, *pe = data + len, *eof, *qstart = NULL, *qend = NULL,
	*pname_start = NULL, *pname_end = NULL, *pvalue_start = NULL, *pvalue_end = NULL;
	int cs, *stack = NULL;
	gsize top = 0;
	struct _ragel_st_storage {
		int *data;
		gsize size;
	} st_storage;
	
	memset (&st_storage, 0, sizeof (st_storage));
	memset (cd, 0, sizeof (*cd));
	eof = pe;
	
	
#line 40 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
	{
		cs = (int)content_type_parser_start;
		top = 0;
	}
	
#line 117 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
	
	
#line 49 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
	{
		if ( p == pe )
			goto _test_eof;
		goto _resume;
		
		_again: {}
		switch ( cs ) {
			case 1: goto _st1;
			case 0: goto _st0;
			case 23: goto _st23;
			case 2: goto _st2;
			case 3: goto _st3;
			case 4: goto _st4;
			case 5: goto _st5;
			case 24: goto _st24;
			case 25: goto _st25;
			case 6: goto _st6;
			case 7: goto _st7;
			case 8: goto _st8;
			case 26: goto _st26;
			case 9: goto _st9;
			case 10: goto _st10;
			case 11: goto _st11;
			case 12: goto _st12;
			case 13: goto _st13;
			case 14: goto _st14;
			case 27: goto _st27;
			case 28: goto _st28;
			case 15: goto _st15;
			case 29: goto _st29;
			case 30: goto _st30;
			case 31: goto _st31;
			case 32: goto _st32;
			case 33: goto _st33;
			case 16: goto _st16;
			case 17: goto _st17;
			case 18: goto _st18;
			case 19: goto _st19;
			case 20: goto _st20;
			case 21: goto _st21;
			case 34: goto _st34;
			case 35: goto _st35;
			case 36: goto _st36;
			case 37: goto _st37;
			case 38: goto _st38;
			case 39: goto _st39;
			case 40: goto _st40;
			case 41: goto _st41;
			case 42: goto _st42;
			case 43: goto _st43;
			case 44: goto _st44;
			case 45: goto _st45;
			case 46: goto _st46;
			case 47: goto _st47;
			case 48: goto _st48;
			case 49: goto _st49;
			case 22: goto _st22;
			case 50: goto _st50;
		}
		
		_resume: {}
		switch ( cs ) {
			case 1:
			goto st_case_1;
			case 0:
			goto st_case_0;
			case 23:
			goto st_case_23;
			case 2:
			goto st_case_2;
			case 3:
			goto st_case_3;
			case 4:
			goto st_case_4;
			case 5:
			goto st_case_5;
			case 24:
			goto st_case_24;
			case 25:
			goto st_case_25;
			case 6:
			goto st_case_6;
			case 7:
			goto st_case_7;
			case 8:
			goto st_case_8;
			case 26:
			goto st_case_26;
			case 9:
			goto st_case_9;
			case 10:
			goto st_case_10;
			case 11:
			goto st_case_11;
			case 12:
			goto st_case_12;
			case 13:
			goto st_case_13;
			case 14:
			goto st_case_14;
			case 27:
			goto st_case_27;
			case 28:
			goto st_case_28;
			case 15:
			goto st_case_15;
			case 29:
			goto st_case_29;
			case 30:
			goto st_case_30;
			case 31:
			goto st_case_31;
			case 32:
			goto st_case_32;
			case 33:
			goto st_case_33;
			case 16:
			goto st_case_16;
			case 17:
			goto st_case_17;
			case 18:
			goto st_case_18;
			case 19:
			goto st_case_19;
			case 20:
			goto st_case_20;
			case 21:
			goto st_case_21;
			case 34:
			goto st_case_34;
			case 35:
			goto st_case_35;
			case 36:
			goto st_case_36;
			case 37:
			goto st_case_37;
			case 38:
			goto st_case_38;
			case 39:
			goto st_case_39;
			case 40:
			goto st_case_40;
			case 41:
			goto st_case_41;
			case 42:
			goto st_case_42;
			case 43:
			goto st_case_43;
			case 44:
			goto st_case_44;
			case 45:
			goto st_case_45;
			case 46:
			goto st_case_46;
			case 47:
			goto st_case_47;
			case 48:
			goto st_case_48;
			case 49:
			goto st_case_49;
			case 22:
			goto st_case_22;
			case 50:
			goto st_case_50;
		}
		goto st_out;
		_st1:
		if ( p == eof ) {
			if ( cs >= 23 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof1;
		st_case_1:
		switch( ( (*( p))) ) {
			case 65: {
				goto _ctr3;
			}
			case 73: {
				goto _ctr4;
			}
			case 97: {
				goto _ctr3;
			}
			case 105: {
				goto _ctr4;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto _ctr2;
				}
			} else if ( ( (*( p))) >= 33 ) {
				goto _ctr2;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto _ctr2;
				}
			} else if ( ( (*( p))) >= 66 ) {
				goto _ctr2;
			}
		} else {
			goto _ctr2;
		}
		{
			goto _st0;
		}
		st_case_0:
		_st0:
		cs = 0;
		goto _pop;
		_ctr2:
		{
#line 4 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
		}
		
#line 273 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st23;
		_ctr62:
		{
#line 7 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
		}
		
#line 282 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st23;
		_st23:
		if ( p == eof ) {
			if ( cs >= 23 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof23;
		st_case_23:
		if ( ( (*( p))) == 59 ) {
			goto _ctr64;
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto _st23;
				}
			} else if ( ( (*( p))) >= 33 ) {
				goto _st23;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto _st23;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto _st23;
			}
		} else {
			goto _st23;
		}
		{
			goto _st0;
		}
		_ctr6:
		{
#line 18 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			qstart = NULL;
			qend = NULL;
			pname_start = p;
			pname_end = NULL;
		}
		
#line 331 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st2;
		_ctr64:
		{
#line 7 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
		}
		
#line 340 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st2;
		_ctr69:
		{
#line 51 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			if (pname_end) {
				if (qstart) {
					pvalue_start = qstart;
				}
				if (qend && qend >= qstart) {
					pvalue_end = qend;
				}
				else if (p >= pvalue_start) {
					pvalue_end = p;
				}
				qstart = NULL;
				qend = NULL;
				
				if (pvalue_end && pvalue_end > pvalue_start && pname_end > pname_start) {
					rspamd_content_disposition_add_param (pool, cd, pname_start, pname_end, pvalue_start, pvalue_end);
				}
			}
			
			pname_start = NULL;
			pname_end = NULL;
			pvalue_start = NULL;
			pvalue_end = NULL;
			qend = NULL;
			qstart = NULL;
		}
		
#line 373 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st2;
		_ctr106:
		{
#line 14 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			cd->type = RSPAMD_CT_ATTACHMENT;
		}
		
#line 383 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		{
#line 7 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
		}
		
#line 390 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st2;
		_ctr118:
		{
#line 10 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			cd->type = RSPAMD_CT_INLINE;
		}
		
#line 400 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		{
#line 7 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
		}
		
#line 407 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st2;
		_st2:
		if ( p == eof ) {
			if ( cs >= 23 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof2;
		st_case_2:
		switch( ( (*( p))) ) {
			case 32: {
				goto _ctr6;
			}
			case 34: {
				goto _ctr8;
			}
			case 40: {
				goto _ctr9;
			}
			case 61: {
				goto _ctr7;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto _ctr7;
				}
			} else if ( ( (*( p))) >= 33 ) {
				goto _ctr7;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto _ctr7;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto _ctr7;
			}
		} else {
			goto _ctr7;
		}
		{
			goto _st0;
		}
		_ctr7:
		{
#line 18 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			qstart = NULL;
			qend = NULL;
			pname_start = p;
			pname_end = NULL;
		}
		
#line 467 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st3;
		_st3:
		if ( p == eof ) {
			if ( cs >= 23 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof3;
		st_case_3:
		switch( ( (*( p))) ) {
			case 32: {
				goto _ctr11;
			}
			case 33: {
				goto _st3;
			}
			case 61: {
				goto _ctr12;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto _st3;
				}
			} else if ( ( (*( p))) >= 35 ) {
				goto _st3;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto _st3;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto _st3;
			}
		} else {
			goto _st3;
		}
		{
			goto _st0;
		}
		_ctr11:
		{
#line 25 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			if (qstart) {
				pname_start = qstart;
			}
			if (qend && qend >= qstart) {
				pname_end = qend;
			}
			else if (p >= pname_start) {
				pname_end = p;
			}
			qstart = NULL;
			qend = NULL;
		}
		
#line 531 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st4;
		_st4:
		if ( p == eof ) {
			if ( cs >= 23 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof4;
		st_case_4:
		switch( ( (*( p))) ) {
			case 32: {
				goto _st4;
			}
			case 61: {
				goto _st5;
			}
		}
		{
			goto _st0;
		}
		_ctr55:
		{
#line 25 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			if (qstart) {
				pname_start = qstart;
			}
			if (qend && qend >= qstart) {
				pname_end = qend;
			}
			else if (p >= pname_start) {
				pname_end = p;
			}
			qstart = NULL;
			qend = NULL;
		}
		
#line 573 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st5;
		_ctr15:
		{
#line 40 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			qstart = NULL;
			qend = NULL;
			
			if (pname_end) {
				pvalue_start = p;
				pvalue_end = NULL;
			}
		}
		
#line 589 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st5;
		_st5:
		if ( p == eof ) {
			if ( cs >= 23 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof5;
		st_case_5:
		switch( ( (*( p))) ) {
			case 32: {
				goto _ctr15;
			}
			case 34: {
				goto _ctr17;
			}
			case 40: {
				goto _ctr18;
			}
			case 61: {
				goto _ctr16;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto _ctr16;
				}
			} else if ( ( (*( p))) >= 33 ) {
				goto _ctr16;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto _ctr16;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto _ctr16;
			}
		} else {
			goto _ctr16;
		}
		{
			goto _st0;
		}
		_ctr16:
		{
#line 40 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			qstart = NULL;
			qend = NULL;
			
			if (pname_end) {
				pvalue_start = p;
				pvalue_end = NULL;
			}
		}
		
#line 652 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st24;
		_ctr65:
		{
#line 51 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			if (pname_end) {
				if (qstart) {
					pvalue_start = qstart;
				}
				if (qend && qend >= qstart) {
					pvalue_end = qend;
				}
				else if (p >= pvalue_start) {
					pvalue_end = p;
				}
				qstart = NULL;
				qend = NULL;
				
				if (pvalue_end && pvalue_end > pvalue_start && pname_end > pname_start) {
					rspamd_content_disposition_add_param (pool, cd, pname_start, pname_end, pvalue_start, pvalue_end);
				}
			}
			
			pname_start = NULL;
			pname_end = NULL;
			pvalue_start = NULL;
			pvalue_end = NULL;
			qend = NULL;
			qstart = NULL;
		}
		
#line 685 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st24;
		_st24:
		if ( p == eof ) {
			if ( cs >= 23 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof24;
		st_case_24:
		switch( ( (*( p))) ) {
			case 32: {
				goto _ctr66;
			}
			case 33: {
				goto _st24;
			}
			case 40: {
				goto _ctr68;
			}
			case 59: {
				goto _ctr69;
			}
			case 61: {
				goto _st24;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto _st24;
				}
			} else if ( ( (*( p))) >= 35 ) {
				goto _st24;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto _st24;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto _st24;
			}
		} else {
			goto _st24;
		}
		{
			goto _st0;
		}
		_ctr66:
		{
#line 51 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			if (pname_end) {
				if (qstart) {
					pvalue_start = qstart;
				}
				if (qend && qend >= qstart) {
					pvalue_end = qend;
				}
				else if (p >= pvalue_start) {
					pvalue_end = p;
				}
				qstart = NULL;
				qend = NULL;
				
				if (pvalue_end && pvalue_end > pvalue_start && pname_end > pname_start) {
					rspamd_content_disposition_add_param (pool, cd, pname_start, pname_end, pvalue_start, pvalue_end);
				}
			}
			
			pname_start = NULL;
			pname_end = NULL;
			pvalue_start = NULL;
			pvalue_end = NULL;
			qend = NULL;
			qstart = NULL;
		}
		
#line 768 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st25;
		_st25:
		if ( p == eof ) {
			if ( cs >= 23 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof25;
		st_case_25:
		switch( ( (*( p))) ) {
			case 32: {
				goto _st25;
			}
			case 40: {
				goto _st6;
			}
			case 59: {
				goto _st2;
			}
		}
		{
			goto _st0;
		}
		_ctr20:
		{
#line 6 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition.rl"
			{{
#line 28 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition.rl"
					
					if (top >= st_storage.size) {
						st_storage.size = (top + 1) * 2;
						st_storage.data = realloc (st_storage.data, st_storage.size * sizeof (int));
						g_assert (st_storage.data != NULL);
						stack = st_storage.data;
					}
				}
				stack[top] = 6; top+= 1; goto _st22;}}
		
#line 811 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st6;
		_ctr68:
		{
#line 51 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			if (pname_end) {
				if (qstart) {
					pvalue_start = qstart;
				}
				if (qend && qend >= qstart) {
					pvalue_end = qend;
				}
				else if (p >= pvalue_start) {
					pvalue_end = p;
				}
				qstart = NULL;
				qend = NULL;
				
				if (pvalue_end && pvalue_end > pvalue_start && pname_end > pname_start) {
					rspamd_content_disposition_add_param (pool, cd, pname_start, pname_end, pvalue_start, pvalue_end);
				}
			}
			
			pname_start = NULL;
			pname_end = NULL;
			pvalue_start = NULL;
			pvalue_end = NULL;
			qend = NULL;
			qstart = NULL;
		}
		
#line 844 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st6;
		_st6:
		if ( p == eof ) {
			if ( cs >= 23 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof6;
		st_case_6:
		switch( ( (*( p))) ) {
			case 40: {
				goto _ctr20;
			}
			case 41: {
				goto _st25;
			}
		}
		if ( ( (*( p))) > 91 ) {
			if ( 93 <= ( (*( p))) && ( (*( p))) <= 126 ) {
				goto _st6;
			}
		} else if ( ( (*( p))) >= 32 ) {
			goto _st6;
		}
		{
			goto _st0;
		}
		_ctr17:
		{
#line 40 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			qstart = NULL;
			qend = NULL;
			
			if (pname_end) {
				pvalue_start = p;
				pvalue_end = NULL;
			}
		}
		
#line 889 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st7;
		_st7:
		if ( p == eof ) {
			if ( cs >= 23 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof7;
		st_case_7:
		switch( ( (*( p))) ) {
			case 34: {
				goto _ctr24;
			}
			case 92: {
				goto _ctr25;
			}
		}
		if ( 32 <= ( (*( p))) && ( (*( p))) <= 126 ) {
			goto _ctr23;
		}
		{
			goto _st0;
		}
		_ctr23:
		{
#line 78 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			qstart = p;
			qend = NULL;
		}
		
#line 925 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st8;
		_st8:
		if ( p == eof ) {
			if ( cs >= 23 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof8;
		st_case_8:
		switch( ( (*( p))) ) {
			case 34: {
				goto _ctr27;
			}
			case 92: {
				goto _st10;
			}
		}
		if ( 32 <= ( (*( p))) && ( (*( p))) <= 126 ) {
			goto _st8;
		}
		{
			goto _st0;
		}
		_ctr24:
		{
#line 78 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			qstart = p;
			qend = NULL;
		}
		
#line 961 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		{
#line 83 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			if (qstart) {
				qend = p;
			}
		}
		
#line 971 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st26;
		_ctr27:
		{
#line 83 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			if (qstart) {
				qend = p;
			}
		}
		
#line 983 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st26;
		_ctr70:
		{
#line 51 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			if (pname_end) {
				if (qstart) {
					pvalue_start = qstart;
				}
				if (qend && qend >= qstart) {
					pvalue_end = qend;
				}
				else if (p >= pvalue_start) {
					pvalue_end = p;
				}
				qstart = NULL;
				qend = NULL;
				
				if (pvalue_end && pvalue_end > pvalue_start && pname_end > pname_start) {
					rspamd_content_disposition_add_param (pool, cd, pname_start, pname_end, pvalue_start, pvalue_end);
				}
			}
			
			pname_start = NULL;
			pname_end = NULL;
			pvalue_start = NULL;
			pvalue_end = NULL;
			qend = NULL;
			qstart = NULL;
		}
		
#line 1016 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st26;
		_st26:
		if ( p == eof ) {
			if ( cs >= 23 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof26;
		st_case_26:
		switch( ( (*( p))) ) {
			case 32: {
				goto _ctr70;
			}
			case 40: {
				goto _ctr71;
			}
			case 59: {
				goto _ctr69;
			}
		}
		{
			goto _st0;
		}
		_ctr30:
		{
#line 6 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition.rl"
			{{
#line 28 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition.rl"
					
					if (top >= st_storage.size) {
						st_storage.size = (top + 1) * 2;
						st_storage.data = realloc (st_storage.data, st_storage.size * sizeof (int));
						g_assert (st_storage.data != NULL);
						stack = st_storage.data;
					}
				}
				stack[top] = 9; top+= 1; goto _st22;}}
		
#line 1059 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st9;
		_ctr71:
		{
#line 51 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			if (pname_end) {
				if (qstart) {
					pvalue_start = qstart;
				}
				if (qend && qend >= qstart) {
					pvalue_end = qend;
				}
				else if (p >= pvalue_start) {
					pvalue_end = p;
				}
				qstart = NULL;
				qend = NULL;
				
				if (pvalue_end && pvalue_end > pvalue_start && pname_end > pname_start) {
					rspamd_content_disposition_add_param (pool, cd, pname_start, pname_end, pvalue_start, pvalue_end);
				}
			}
			
			pname_start = NULL;
			pname_end = NULL;
			pvalue_start = NULL;
			pvalue_end = NULL;
			qend = NULL;
			qstart = NULL;
		}
		
#line 1092 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st9;
		_st9:
		if ( p == eof ) {
			if ( cs >= 23 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof9;
		st_case_9:
		switch( ( (*( p))) ) {
			case 40: {
				goto _ctr30;
			}
			case 41: {
				goto _st26;
			}
		}
		if ( ( (*( p))) > 91 ) {
			if ( 93 <= ( (*( p))) && ( (*( p))) <= 126 ) {
				goto _st9;
			}
		} else if ( ( (*( p))) >= 32 ) {
			goto _st9;
		}
		{
			goto _st0;
		}
		_ctr25:
		{
#line 78 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			qstart = p;
			qend = NULL;
		}
		
#line 1132 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st10;
		_st10:
		if ( p == eof ) {
			if ( cs >= 23 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof10;
		st_case_10:
		if ( 32 <= ( (*( p))) && ( (*( p))) <= 126 ) {
			goto _st8;
		}
		{
			goto _st0;
		}
		_ctr18:
		{
#line 40 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			qstart = NULL;
			qend = NULL;
			
			if (pname_end) {
				pvalue_start = p;
				pvalue_end = NULL;
			}
		}
		
#line 1165 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st11;
		_ctr33:
		{
#line 6 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition.rl"
			{{
#line 28 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition.rl"
					
					if (top >= st_storage.size) {
						st_storage.size = (top + 1) * 2;
						st_storage.data = realloc (st_storage.data, st_storage.size * sizeof (int));
						g_assert (st_storage.data != NULL);
						stack = st_storage.data;
					}
				}
				stack[top] = 11; top+= 1; goto _st22;}}
		
#line 1183 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st11;
		_st11:
		if ( p == eof ) {
			if ( cs >= 23 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof11;
		st_case_11:
		switch( ( (*( p))) ) {
			case 40: {
				goto _ctr33;
			}
			case 41: {
				goto _st12;
			}
		}
		if ( ( (*( p))) > 91 ) {
			if ( 93 <= ( (*( p))) && ( (*( p))) <= 126 ) {
				goto _st11;
			}
		} else if ( ( (*( p))) >= 32 ) {
			goto _st11;
		}
		{
			goto _st0;
		}
		_st12:
		if ( p == eof ) {
			if ( cs >= 23 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof12;
		st_case_12:
		switch( ( (*( p))) ) {
			case 32: {
				goto _st12;
			}
			case 34: {
				goto _st7;
			}
			case 40: {
				goto _st11;
			}
		}
		{
			goto _st0;
		}
		_ctr12:
		{
#line 25 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			if (qstart) {
				pname_start = qstart;
			}
			if (qend && qend >= qstart) {
				pname_end = qend;
			}
			else if (p >= pname_start) {
				pname_end = p;
			}
			qstart = NULL;
			qend = NULL;
		}
		
#line 1257 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st13;
		_st13:
		if ( p == eof ) {
			if ( cs >= 23 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof13;
		st_case_13:
		switch( ( (*( p))) ) {
			case 32: {
				goto _ctr36;
			}
			case 34: {
				goto _ctr17;
			}
			case 40: {
				goto _ctr18;
			}
			case 61: {
				goto _ctr38;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto _ctr37;
				}
			} else if ( ( (*( p))) >= 33 ) {
				goto _ctr37;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto _ctr37;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto _ctr37;
			}
		} else {
			goto _ctr37;
		}
		{
			goto _st0;
		}
		_ctr40:
		{
#line 40 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			qstart = NULL;
			qend = NULL;
			
			if (pname_end) {
				pvalue_start = p;
				pvalue_end = NULL;
			}
		}
		
#line 1320 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st14;
		_ctr36:
		{
#line 25 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			if (qstart) {
				pname_start = qstart;
			}
			if (qend && qend >= qstart) {
				pname_end = qend;
			}
			else if (p >= pname_start) {
				pname_end = p;
			}
			qstart = NULL;
			qend = NULL;
		}
		
#line 1340 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		{
#line 40 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			qstart = NULL;
			qend = NULL;
			
			if (pname_end) {
				pvalue_start = p;
				pvalue_end = NULL;
			}
		}
		
#line 1354 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st14;
		_st14:
		if ( p == eof ) {
			if ( cs >= 23 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof14;
		st_case_14:
		switch( ( (*( p))) ) {
			case 32: {
				goto _ctr40;
			}
			case 34: {
				goto _ctr17;
			}
			case 40: {
				goto _ctr18;
			}
			case 61: {
				goto _ctr41;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto _ctr16;
				}
			} else if ( ( (*( p))) >= 33 ) {
				goto _ctr16;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto _ctr16;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto _ctr16;
			}
		} else {
			goto _ctr16;
		}
		{
			goto _st0;
		}
		_ctr41:
		{
#line 40 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			qstart = NULL;
			qend = NULL;
			
			if (pname_end) {
				pvalue_start = p;
				pvalue_end = NULL;
			}
		}
		
#line 1417 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st27;
		_ctr72:
		{
#line 51 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			if (pname_end) {
				if (qstart) {
					pvalue_start = qstart;
				}
				if (qend && qend >= qstart) {
					pvalue_end = qend;
				}
				else if (p >= pvalue_start) {
					pvalue_end = p;
				}
				qstart = NULL;
				qend = NULL;
				
				if (pvalue_end && pvalue_end > pvalue_start && pname_end > pname_start) {
					rspamd_content_disposition_add_param (pool, cd, pname_start, pname_end, pvalue_start, pvalue_end);
				}
			}
			
			pname_start = NULL;
			pname_end = NULL;
			pvalue_start = NULL;
			pvalue_end = NULL;
			qend = NULL;
			qstart = NULL;
		}
		
#line 1450 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st27;
		_st27:
		if ( p == eof ) {
			if ( cs >= 23 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof27;
		st_case_27:
		switch( ( (*( p))) ) {
			case 32: {
				goto _ctr73;
			}
			case 34: {
				goto _ctr17;
			}
			case 40: {
				goto _ctr74;
			}
			case 59: {
				goto _ctr69;
			}
			case 61: {
				goto _ctr16;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto _ctr16;
				}
			} else if ( ( (*( p))) >= 33 ) {
				goto _ctr16;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto _ctr16;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto _ctr16;
			}
		} else {
			goto _ctr16;
		}
		{
			goto _st0;
		}
		_ctr76:
		{
#line 40 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			qstart = NULL;
			qend = NULL;
			
			if (pname_end) {
				pvalue_start = p;
				pvalue_end = NULL;
			}
		}
		
#line 1516 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st28;
		_ctr73:
		{
#line 40 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			qstart = NULL;
			qend = NULL;
			
			if (pname_end) {
				pvalue_start = p;
				pvalue_end = NULL;
			}
		}
		
#line 1532 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		{
#line 51 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			if (pname_end) {
				if (qstart) {
					pvalue_start = qstart;
				}
				if (qend && qend >= qstart) {
					pvalue_end = qend;
				}
				else if (p >= pvalue_start) {
					pvalue_end = p;
				}
				qstart = NULL;
				qend = NULL;
				
				if (pvalue_end && pvalue_end > pvalue_start && pname_end > pname_start) {
					rspamd_content_disposition_add_param (pool, cd, pname_start, pname_end, pvalue_start, pvalue_end);
				}
			}
			
			pname_start = NULL;
			pname_end = NULL;
			pvalue_start = NULL;
			pvalue_end = NULL;
			qend = NULL;
			qstart = NULL;
		}
		
#line 1563 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st28;
		_st28:
		if ( p == eof ) {
			if ( cs >= 23 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof28;
		st_case_28:
		switch( ( (*( p))) ) {
			case 32: {
				goto _ctr76;
			}
			case 34: {
				goto _ctr17;
			}
			case 40: {
				goto _ctr77;
			}
			case 59: {
				goto _st2;
			}
			case 61: {
				goto _ctr16;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto _ctr16;
				}
			} else if ( ( (*( p))) >= 33 ) {
				goto _ctr16;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto _ctr16;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto _ctr16;
			}
		} else {
			goto _ctr16;
		}
		{
			goto _st0;
		}
		_ctr77:
		{
#line 40 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			qstart = NULL;
			qend = NULL;
			
			if (pname_end) {
				pvalue_start = p;
				pvalue_end = NULL;
			}
		}
		
#line 1629 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st15;
		_ctr43:
		{
#line 6 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition.rl"
			{{
#line 28 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition.rl"
					
					if (top >= st_storage.size) {
						st_storage.size = (top + 1) * 2;
						st_storage.data = realloc (st_storage.data, st_storage.size * sizeof (int));
						g_assert (st_storage.data != NULL);
						stack = st_storage.data;
					}
				}
				stack[top] = 15; top+= 1; goto _st22;}}
		
#line 1647 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st15;
		_ctr74:
		{
#line 40 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			qstart = NULL;
			qend = NULL;
			
			if (pname_end) {
				pvalue_start = p;
				pvalue_end = NULL;
			}
		}
		
#line 1663 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		{
#line 51 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			if (pname_end) {
				if (qstart) {
					pvalue_start = qstart;
				}
				if (qend && qend >= qstart) {
					pvalue_end = qend;
				}
				else if (p >= pvalue_start) {
					pvalue_end = p;
				}
				qstart = NULL;
				qend = NULL;
				
				if (pvalue_end && pvalue_end > pvalue_start && pname_end > pname_start) {
					rspamd_content_disposition_add_param (pool, cd, pname_start, pname_end, pvalue_start, pvalue_end);
				}
			}
			
			pname_start = NULL;
			pname_end = NULL;
			pvalue_start = NULL;
			pvalue_end = NULL;
			qend = NULL;
			qstart = NULL;
		}
		
#line 1694 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st15;
		_st15:
		if ( p == eof ) {
			if ( cs >= 23 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof15;
		st_case_15:
		switch( ( (*( p))) ) {
			case 40: {
				goto _ctr43;
			}
			case 41: {
				goto _st29;
			}
		}
		if ( ( (*( p))) > 91 ) {
			if ( 93 <= ( (*( p))) && ( (*( p))) <= 126 ) {
				goto _st15;
			}
		} else if ( ( (*( p))) >= 32 ) {
			goto _st15;
		}
		{
			goto _st0;
		}
		_st29:
		if ( p == eof ) {
			if ( cs >= 23 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof29;
		st_case_29:
		switch( ( (*( p))) ) {
			case 32: {
				goto _st29;
			}
			case 34: {
				goto _st7;
			}
			case 40: {
				goto _st15;
			}
			case 59: {
				goto _st2;
			}
		}
		{
			goto _st0;
		}
		_ctr37:
		{
#line 40 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			qstart = NULL;
			qend = NULL;
			
			if (pname_end) {
				pvalue_start = p;
				pvalue_end = NULL;
			}
		}
		
#line 1767 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st30;
		_ctr78:
		{
#line 51 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			if (pname_end) {
				if (qstart) {
					pvalue_start = qstart;
				}
				if (qend && qend >= qstart) {
					pvalue_end = qend;
				}
				else if (p >= pvalue_start) {
					pvalue_end = p;
				}
				qstart = NULL;
				qend = NULL;
				
				if (pvalue_end && pvalue_end > pvalue_start && pname_end > pname_start) {
					rspamd_content_disposition_add_param (pool, cd, pname_start, pname_end, pvalue_start, pvalue_end);
				}
			}
			
			pname_start = NULL;
			pname_end = NULL;
			pvalue_start = NULL;
			pvalue_end = NULL;
			qend = NULL;
			qstart = NULL;
		}
		
#line 1800 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st30;
		_st30:
		if ( p == eof ) {
			if ( cs >= 23 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof30;
		st_case_30:
		switch( ( (*( p))) ) {
			case 32: {
				goto _ctr79;
			}
			case 33: {
				goto _st30;
			}
			case 40: {
				goto _ctr68;
			}
			case 59: {
				goto _ctr69;
			}
			case 61: {
				goto _ctr81;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto _st30;
				}
			} else if ( ( (*( p))) >= 35 ) {
				goto _st30;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto _st30;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto _st30;
			}
		} else {
			goto _st30;
		}
		{
			goto _st0;
		}
		_ctr79:
		{
#line 25 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			if (qstart) {
				pname_start = qstart;
			}
			if (qend && qend >= qstart) {
				pname_end = qend;
			}
			else if (p >= pname_start) {
				pname_end = p;
			}
			qstart = NULL;
			qend = NULL;
		}
		
#line 1870 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		{
#line 51 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			if (pname_end) {
				if (qstart) {
					pvalue_start = qstart;
				}
				if (qend && qend >= qstart) {
					pvalue_end = qend;
				}
				else if (p >= pvalue_start) {
					pvalue_end = p;
				}
				qstart = NULL;
				qend = NULL;
				
				if (pvalue_end && pvalue_end > pvalue_start && pname_end > pname_start) {
					rspamd_content_disposition_add_param (pool, cd, pname_start, pname_end, pvalue_start, pvalue_end);
				}
			}
			
			pname_start = NULL;
			pname_end = NULL;
			pvalue_start = NULL;
			pvalue_end = NULL;
			qend = NULL;
			qstart = NULL;
		}
		
#line 1901 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st31;
		_st31:
		if ( p == eof ) {
			if ( cs >= 23 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof31;
		st_case_31:
		switch( ( (*( p))) ) {
			case 32: {
				goto _st31;
			}
			case 40: {
				goto _st6;
			}
			case 59: {
				goto _st2;
			}
			case 61: {
				goto _st5;
			}
		}
		{
			goto _st0;
		}
		_ctr81:
		{
#line 25 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			if (qstart) {
				pname_start = qstart;
			}
			if (qend && qend >= qstart) {
				pname_end = qend;
			}
			else if (p >= pname_start) {
				pname_end = p;
			}
			qstart = NULL;
			qend = NULL;
		}
		
#line 1949 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st32;
		_ctr38:
		{
#line 25 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			if (qstart) {
				pname_start = qstart;
			}
			if (qend && qend >= qstart) {
				pname_end = qend;
			}
			else if (p >= pname_start) {
				pname_end = p;
			}
			qstart = NULL;
			qend = NULL;
		}
		
#line 1969 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		{
#line 40 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			qstart = NULL;
			qend = NULL;
			
			if (pname_end) {
				pvalue_start = p;
				pvalue_end = NULL;
			}
		}
		
#line 1983 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st32;
		_ctr83:
		{
#line 51 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			if (pname_end) {
				if (qstart) {
					pvalue_start = qstart;
				}
				if (qend && qend >= qstart) {
					pvalue_end = qend;
				}
				else if (p >= pvalue_start) {
					pvalue_end = p;
				}
				qstart = NULL;
				qend = NULL;
				
				if (pvalue_end && pvalue_end > pvalue_start && pname_end > pname_start) {
					rspamd_content_disposition_add_param (pool, cd, pname_start, pname_end, pvalue_start, pvalue_end);
				}
			}
			
			pname_start = NULL;
			pname_end = NULL;
			pvalue_start = NULL;
			pvalue_end = NULL;
			qend = NULL;
			qstart = NULL;
		}
		
#line 2016 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st32;
		_st32:
		if ( p == eof ) {
			if ( cs >= 23 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof32;
		st_case_32:
		switch( ( (*( p))) ) {
			case 32: {
				goto _ctr84;
			}
			case 34: {
				goto _ctr17;
			}
			case 40: {
				goto _ctr74;
			}
			case 59: {
				goto _ctr69;
			}
			case 61: {
				goto _ctr38;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto _ctr37;
				}
			} else if ( ( (*( p))) >= 33 ) {
				goto _ctr37;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto _ctr37;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto _ctr37;
			}
		} else {
			goto _ctr37;
		}
		{
			goto _st0;
		}
		_ctr86:
		{
#line 40 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			qstart = NULL;
			qend = NULL;
			
			if (pname_end) {
				pvalue_start = p;
				pvalue_end = NULL;
			}
		}
		
#line 2082 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st33;
		_ctr84:
		{
#line 25 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			if (qstart) {
				pname_start = qstart;
			}
			if (qend && qend >= qstart) {
				pname_end = qend;
			}
			else if (p >= pname_start) {
				pname_end = p;
			}
			qstart = NULL;
			qend = NULL;
		}
		
#line 2102 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		{
#line 40 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			qstart = NULL;
			qend = NULL;
			
			if (pname_end) {
				pvalue_start = p;
				pvalue_end = NULL;
			}
		}
		
#line 2116 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		{
#line 51 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			if (pname_end) {
				if (qstart) {
					pvalue_start = qstart;
				}
				if (qend && qend >= qstart) {
					pvalue_end = qend;
				}
				else if (p >= pvalue_start) {
					pvalue_end = p;
				}
				qstart = NULL;
				qend = NULL;
				
				if (pvalue_end && pvalue_end > pvalue_start && pname_end > pname_start) {
					rspamd_content_disposition_add_param (pool, cd, pname_start, pname_end, pvalue_start, pvalue_end);
				}
			}
			
			pname_start = NULL;
			pname_end = NULL;
			pvalue_start = NULL;
			pvalue_end = NULL;
			qend = NULL;
			qstart = NULL;
		}
		
#line 2147 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st33;
		_st33:
		if ( p == eof ) {
			if ( cs >= 23 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof33;
		st_case_33:
		switch( ( (*( p))) ) {
			case 32: {
				goto _ctr86;
			}
			case 34: {
				goto _ctr17;
			}
			case 40: {
				goto _ctr77;
			}
			case 59: {
				goto _st2;
			}
			case 61: {
				goto _ctr41;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto _ctr16;
				}
			} else if ( ( (*( p))) >= 33 ) {
				goto _ctr16;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto _ctr16;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto _ctr16;
			}
		} else {
			goto _ctr16;
		}
		{
			goto _st0;
		}
		_ctr8:
		{
#line 18 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			qstart = NULL;
			qend = NULL;
			pname_start = p;
			pname_end = NULL;
		}
		
#line 2210 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st16;
		_st16:
		if ( p == eof ) {
			if ( cs >= 23 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof16;
		st_case_16:
		switch( ( (*( p))) ) {
			case 34: {
				goto _ctr47;
			}
			case 92: {
				goto _ctr48;
			}
		}
		if ( 32 <= ( (*( p))) && ( (*( p))) <= 126 ) {
			goto _ctr46;
		}
		{
			goto _st0;
		}
		_ctr46:
		{
#line 78 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			qstart = p;
			qend = NULL;
		}
		
#line 2246 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st17;
		_st17:
		if ( p == eof ) {
			if ( cs >= 23 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof17;
		st_case_17:
		switch( ( (*( p))) ) {
			case 34: {
				goto _ctr50;
			}
			case 92: {
				goto _st20;
			}
		}
		if ( 32 <= ( (*( p))) && ( (*( p))) <= 126 ) {
			goto _st17;
		}
		{
			goto _st0;
		}
		_ctr53:
		{
#line 25 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			if (qstart) {
				pname_start = qstart;
			}
			if (qend && qend >= qstart) {
				pname_end = qend;
			}
			else if (p >= pname_start) {
				pname_end = p;
			}
			qstart = NULL;
			qend = NULL;
		}
		
#line 2291 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st18;
		_ctr47:
		{
#line 78 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			qstart = p;
			qend = NULL;
		}
		
#line 2302 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		{
#line 83 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			if (qstart) {
				qend = p;
			}
		}
		
#line 2312 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st18;
		_ctr50:
		{
#line 83 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			if (qstart) {
				qend = p;
			}
		}
		
#line 2324 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st18;
		_st18:
		if ( p == eof ) {
			if ( cs >= 23 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof18;
		st_case_18:
		switch( ( (*( p))) ) {
			case 32: {
				goto _ctr53;
			}
			case 40: {
				goto _st19;
			}
			case 61: {
				goto _ctr55;
			}
		}
		{
			goto _st0;
		}
		_ctr56:
		{
#line 6 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition.rl"
			{{
#line 28 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition.rl"
					
					if (top >= st_storage.size) {
						st_storage.size = (top + 1) * 2;
						st_storage.data = realloc (st_storage.data, st_storage.size * sizeof (int));
						g_assert (st_storage.data != NULL);
						stack = st_storage.data;
					}
				}
				stack[top] = 19; top+= 1; goto _st22;}}
		
#line 2367 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st19;
		_st19:
		if ( p == eof ) {
			if ( cs >= 23 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof19;
		st_case_19:
		switch( ( (*( p))) ) {
			case 40: {
				goto _ctr56;
			}
			case 41: {
				goto _st18;
			}
		}
		if ( ( (*( p))) > 91 ) {
			if ( 93 <= ( (*( p))) && ( (*( p))) <= 126 ) {
				goto _st19;
			}
		} else if ( ( (*( p))) >= 32 ) {
			goto _st19;
		}
		{
			goto _st0;
		}
		_ctr48:
		{
#line 78 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			qstart = p;
			qend = NULL;
		}
		
#line 2407 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st20;
		_st20:
		if ( p == eof ) {
			if ( cs >= 23 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof20;
		st_case_20:
		if ( 32 <= ( (*( p))) && ( (*( p))) <= 126 ) {
			goto _st17;
		}
		{
			goto _st0;
		}
		_ctr9:
		{
#line 18 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			qstart = NULL;
			qend = NULL;
			pname_start = p;
			pname_end = NULL;
		}
		
#line 2437 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st21;
		_ctr58:
		{
#line 6 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition.rl"
			{{
#line 28 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition.rl"
					
					if (top >= st_storage.size) {
						st_storage.size = (top + 1) * 2;
						st_storage.data = realloc (st_storage.data, st_storage.size * sizeof (int));
						g_assert (st_storage.data != NULL);
						stack = st_storage.data;
					}
				}
				stack[top] = 21; top+= 1; goto _st22;}}
		
#line 2455 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st21;
		_st21:
		if ( p == eof ) {
			if ( cs >= 23 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof21;
		st_case_21:
		switch( ( (*( p))) ) {
			case 40: {
				goto _ctr58;
			}
			case 41: {
				goto _st2;
			}
		}
		if ( ( (*( p))) > 91 ) {
			if ( 93 <= ( (*( p))) && ( (*( p))) <= 126 ) {
				goto _st21;
			}
		} else if ( ( (*( p))) >= 32 ) {
			goto _st21;
		}
		{
			goto _st0;
		}
		_ctr3:
		{
#line 4 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
		}
		
#line 2493 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st34;
		_ctr87:
		{
#line 7 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
		}
		
#line 2502 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st34;
		_st34:
		if ( p == eof ) {
			if ( cs >= 23 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof34;
		st_case_34:
		switch( ( (*( p))) ) {
			case 59: {
				goto _ctr64;
			}
			case 84: {
				goto _st35;
			}
			case 116: {
				goto _st35;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto _st23;
				}
			} else if ( ( (*( p))) >= 33 ) {
				goto _st23;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto _st23;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto _st23;
			}
		} else {
			goto _st23;
		}
		{
			goto _st0;
		}
		_ctr89:
		{
#line 7 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
		}
		
#line 2555 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st35;
		_st35:
		if ( p == eof ) {
			if ( cs >= 23 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof35;
		st_case_35:
		switch( ( (*( p))) ) {
			case 59: {
				goto _ctr64;
			}
			case 84: {
				goto _st36;
			}
			case 116: {
				goto _st36;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto _st23;
				}
			} else if ( ( (*( p))) >= 33 ) {
				goto _st23;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto _st23;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto _st23;
			}
		} else {
			goto _st23;
		}
		{
			goto _st0;
		}
		_ctr91:
		{
#line 7 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
		}
		
#line 2608 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st36;
		_st36:
		if ( p == eof ) {
			if ( cs >= 23 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof36;
		st_case_36:
		switch( ( (*( p))) ) {
			case 59: {
				goto _ctr64;
			}
			case 65: {
				goto _st37;
			}
			case 97: {
				goto _st37;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto _st23;
				}
			} else if ( ( (*( p))) >= 33 ) {
				goto _st23;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto _st23;
				}
			} else if ( ( (*( p))) >= 66 ) {
				goto _st23;
			}
		} else {
			goto _st23;
		}
		{
			goto _st0;
		}
		_ctr93:
		{
#line 7 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
		}
		
#line 2661 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st37;
		_st37:
		if ( p == eof ) {
			if ( cs >= 23 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof37;
		st_case_37:
		switch( ( (*( p))) ) {
			case 59: {
				goto _ctr64;
			}
			case 67: {
				goto _st38;
			}
			case 99: {
				goto _st38;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto _st23;
				}
			} else if ( ( (*( p))) >= 33 ) {
				goto _st23;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto _st23;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto _st23;
			}
		} else {
			goto _st23;
		}
		{
			goto _st0;
		}
		_ctr95:
		{
#line 7 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
		}
		
#line 2714 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st38;
		_st38:
		if ( p == eof ) {
			if ( cs >= 23 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof38;
		st_case_38:
		switch( ( (*( p))) ) {
			case 59: {
				goto _ctr64;
			}
			case 72: {
				goto _st39;
			}
			case 104: {
				goto _st39;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto _st23;
				}
			} else if ( ( (*( p))) >= 33 ) {
				goto _st23;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto _st23;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto _st23;
			}
		} else {
			goto _st23;
		}
		{
			goto _st0;
		}
		_ctr97:
		{
#line 7 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
		}
		
#line 2767 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st39;
		_st39:
		if ( p == eof ) {
			if ( cs >= 23 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof39;
		st_case_39:
		switch( ( (*( p))) ) {
			case 59: {
				goto _ctr64;
			}
			case 77: {
				goto _st40;
			}
			case 109: {
				goto _st40;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto _st23;
				}
			} else if ( ( (*( p))) >= 33 ) {
				goto _st23;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto _st23;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto _st23;
			}
		} else {
			goto _st23;
		}
		{
			goto _st0;
		}
		_ctr99:
		{
#line 7 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
		}
		
#line 2820 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st40;
		_st40:
		if ( p == eof ) {
			if ( cs >= 23 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof40;
		st_case_40:
		switch( ( (*( p))) ) {
			case 59: {
				goto _ctr64;
			}
			case 69: {
				goto _st41;
			}
			case 101: {
				goto _st41;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto _st23;
				}
			} else if ( ( (*( p))) >= 33 ) {
				goto _st23;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto _st23;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto _st23;
			}
		} else {
			goto _st23;
		}
		{
			goto _st0;
		}
		_ctr101:
		{
#line 7 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
		}
		
#line 2873 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st41;
		_st41:
		if ( p == eof ) {
			if ( cs >= 23 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof41;
		st_case_41:
		switch( ( (*( p))) ) {
			case 59: {
				goto _ctr64;
			}
			case 78: {
				goto _st42;
			}
			case 110: {
				goto _st42;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto _st23;
				}
			} else if ( ( (*( p))) >= 33 ) {
				goto _st23;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto _st23;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto _st23;
			}
		} else {
			goto _st23;
		}
		{
			goto _st0;
		}
		_ctr103:
		{
#line 7 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
		}
		
#line 2926 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st42;
		_st42:
		if ( p == eof ) {
			if ( cs >= 23 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof42;
		st_case_42:
		switch( ( (*( p))) ) {
			case 59: {
				goto _ctr64;
			}
			case 84: {
				goto _st43;
			}
			case 116: {
				goto _st43;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto _st23;
				}
			} else if ( ( (*( p))) >= 33 ) {
				goto _st23;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto _st23;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto _st23;
			}
		} else {
			goto _st23;
		}
		{
			goto _st0;
		}
		_ctr105:
		{
#line 14 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			cd->type = RSPAMD_CT_ATTACHMENT;
		}
		
#line 2980 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		{
#line 7 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
		}
		
#line 2987 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st43;
		_st43:
		if ( p == eof ) {
			if ( cs >= 23 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof43;
		st_case_43:
		if ( ( (*( p))) == 59 ) {
			goto _ctr106;
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto _st23;
				}
			} else if ( ( (*( p))) >= 33 ) {
				goto _st23;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto _st23;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto _st23;
			}
		} else {
			goto _st23;
		}
		{
			goto _st0;
		}
		_ctr4:
		{
#line 4 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
		}
		
#line 3032 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st44;
		_ctr107:
		{
#line 7 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
		}
		
#line 3041 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st44;
		_st44:
		if ( p == eof ) {
			if ( cs >= 23 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof44;
		st_case_44:
		switch( ( (*( p))) ) {
			case 59: {
				goto _ctr64;
			}
			case 78: {
				goto _st45;
			}
			case 110: {
				goto _st45;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto _st23;
				}
			} else if ( ( (*( p))) >= 33 ) {
				goto _st23;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto _st23;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto _st23;
			}
		} else {
			goto _st23;
		}
		{
			goto _st0;
		}
		_ctr109:
		{
#line 7 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
		}
		
#line 3094 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st45;
		_st45:
		if ( p == eof ) {
			if ( cs >= 23 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof45;
		st_case_45:
		switch( ( (*( p))) ) {
			case 59: {
				goto _ctr64;
			}
			case 76: {
				goto _st46;
			}
			case 108: {
				goto _st46;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto _st23;
				}
			} else if ( ( (*( p))) >= 33 ) {
				goto _st23;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto _st23;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto _st23;
			}
		} else {
			goto _st23;
		}
		{
			goto _st0;
		}
		_ctr111:
		{
#line 7 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
		}
		
#line 3147 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st46;
		_st46:
		if ( p == eof ) {
			if ( cs >= 23 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof46;
		st_case_46:
		switch( ( (*( p))) ) {
			case 59: {
				goto _ctr64;
			}
			case 73: {
				goto _st47;
			}
			case 105: {
				goto _st47;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto _st23;
				}
			} else if ( ( (*( p))) >= 33 ) {
				goto _st23;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto _st23;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto _st23;
			}
		} else {
			goto _st23;
		}
		{
			goto _st0;
		}
		_ctr113:
		{
#line 7 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
		}
		
#line 3200 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st47;
		_st47:
		if ( p == eof ) {
			if ( cs >= 23 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof47;
		st_case_47:
		switch( ( (*( p))) ) {
			case 59: {
				goto _ctr64;
			}
			case 78: {
				goto _st48;
			}
			case 110: {
				goto _st48;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto _st23;
				}
			} else if ( ( (*( p))) >= 33 ) {
				goto _st23;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto _st23;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto _st23;
			}
		} else {
			goto _st23;
		}
		{
			goto _st0;
		}
		_ctr115:
		{
#line 7 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
		}
		
#line 3253 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st48;
		_st48:
		if ( p == eof ) {
			if ( cs >= 23 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof48;
		st_case_48:
		switch( ( (*( p))) ) {
			case 59: {
				goto _ctr64;
			}
			case 69: {
				goto _st49;
			}
			case 101: {
				goto _st49;
			}
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto _st23;
				}
			} else if ( ( (*( p))) >= 33 ) {
				goto _st23;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto _st23;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto _st23;
			}
		} else {
			goto _st23;
		}
		{
			goto _st0;
		}
		_ctr117:
		{
#line 10 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
			cd->type = RSPAMD_CT_INLINE;
		}
		
#line 3307 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		{
#line 7 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
			
		}
		
#line 3314 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st49;
		_st49:
		if ( p == eof ) {
			if ( cs >= 23 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof49;
		st_case_49:
		if ( ( (*( p))) == 59 ) {
			goto _ctr118;
		}
		if ( ( (*( p))) < 48 ) {
			if ( ( (*( p))) > 39 ) {
				if ( 42 <= ( (*( p))) && ( (*( p))) <= 46 ) {
					goto _st23;
				}
			} else if ( ( (*( p))) >= 33 ) {
				goto _st23;
			}
		} else if ( ( (*( p))) > 57 ) {
			if ( ( (*( p))) > 90 ) {
				if ( 94 <= ( (*( p))) && ( (*( p))) <= 126 ) {
					goto _st23;
				}
			} else if ( ( (*( p))) >= 65 ) {
				goto _st23;
			}
		} else {
			goto _st23;
		}
		{
			goto _st0;
		}
		_ctr60:
		{
#line 6 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition.rl"
			{{
#line 28 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition.rl"
					
					if (top >= st_storage.size) {
						st_storage.size = (top + 1) * 2;
						st_storage.data = realloc (st_storage.data, st_storage.size * sizeof (int));
						g_assert (st_storage.data != NULL);
						stack = st_storage.data;
					}
				}
				stack[top] = 22; top+= 1; goto _st22;}}
		
#line 3368 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st22;
		_st22:
		if ( p == eof ) {
			if ( cs >= 23 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof22;
		st_case_22:
		switch( ( (*( p))) ) {
			case 40: {
				goto _ctr60;
			}
			case 41: {
				goto _ctr61;
			}
		}
		if ( ( (*( p))) > 91 ) {
			if ( 93 <= ( (*( p))) && ( (*( p))) <= 126 ) {
				goto _st22;
			}
		} else if ( ( (*( p))) >= 32 ) {
			goto _st22;
		}
		{
			goto _st0;
		}
		_ctr61:
		{
#line 7 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition.rl"
			{top -= 1;cs = stack[top];goto _again;} }
		
#line 3405 "/builddir/build/BUILD/rspamd-2.2/src/content_disposition.rl.c"
		
		goto _st50;
		_st50:
		if ( p == eof ) {
			if ( cs >= 23 )
				goto _out;
			else
				goto _pop;
		}
		p+= 1;
		if ( p == pe )
			goto _test_eof50;
		st_case_50:
		{
			goto _st0;
		}
		st_out:
		_test_eof1: cs = 1; goto _test_eof; 
		_test_eof23: cs = 23; goto _test_eof; 
		_test_eof2: cs = 2; goto _test_eof; 
		_test_eof3: cs = 3; goto _test_eof; 
		_test_eof4: cs = 4; goto _test_eof; 
		_test_eof5: cs = 5; goto _test_eof; 
		_test_eof24: cs = 24; goto _test_eof; 
		_test_eof25: cs = 25; goto _test_eof; 
		_test_eof6: cs = 6; goto _test_eof; 
		_test_eof7: cs = 7; goto _test_eof; 
		_test_eof8: cs = 8; goto _test_eof; 
		_test_eof26: cs = 26; goto _test_eof; 
		_test_eof9: cs = 9; goto _test_eof; 
		_test_eof10: cs = 10; goto _test_eof; 
		_test_eof11: cs = 11; goto _test_eof; 
		_test_eof12: cs = 12; goto _test_eof; 
		_test_eof13: cs = 13; goto _test_eof; 
		_test_eof14: cs = 14; goto _test_eof; 
		_test_eof27: cs = 27; goto _test_eof; 
		_test_eof28: cs = 28; goto _test_eof; 
		_test_eof15: cs = 15; goto _test_eof; 
		_test_eof29: cs = 29; goto _test_eof; 
		_test_eof30: cs = 30; goto _test_eof; 
		_test_eof31: cs = 31; goto _test_eof; 
		_test_eof32: cs = 32; goto _test_eof; 
		_test_eof33: cs = 33; goto _test_eof; 
		_test_eof16: cs = 16; goto _test_eof; 
		_test_eof17: cs = 17; goto _test_eof; 
		_test_eof18: cs = 18; goto _test_eof; 
		_test_eof19: cs = 19; goto _test_eof; 
		_test_eof20: cs = 20; goto _test_eof; 
		_test_eof21: cs = 21; goto _test_eof; 
		_test_eof34: cs = 34; goto _test_eof; 
		_test_eof35: cs = 35; goto _test_eof; 
		_test_eof36: cs = 36; goto _test_eof; 
		_test_eof37: cs = 37; goto _test_eof; 
		_test_eof38: cs = 38; goto _test_eof; 
		_test_eof39: cs = 39; goto _test_eof; 
		_test_eof40: cs = 40; goto _test_eof; 
		_test_eof41: cs = 41; goto _test_eof; 
		_test_eof42: cs = 42; goto _test_eof; 
		_test_eof43: cs = 43; goto _test_eof; 
		_test_eof44: cs = 44; goto _test_eof; 
		_test_eof45: cs = 45; goto _test_eof; 
		_test_eof46: cs = 46; goto _test_eof; 
		_test_eof47: cs = 47; goto _test_eof; 
		_test_eof48: cs = 48; goto _test_eof; 
		_test_eof49: cs = 49; goto _test_eof; 
		_test_eof22: cs = 22; goto _test_eof; 
		_test_eof50: cs = 50; goto _test_eof; 
		
		_test_eof: {}
		if ( p == eof ) {
			switch ( cs ) {
				case 1: {
					break;
				}
				case 0: {
					break;
				}
				case 23: {
					break;
				}
				case 2: {
					break;
				}
				case 3: {
					break;
				}
				case 4: {
					break;
				}
				case 5: {
					break;
				}
				case 24: {
					break;
				}
				case 25: {
					break;
				}
				case 6: {
					break;
				}
				case 7: {
					break;
				}
				case 8: {
					break;
				}
				case 26: {
					break;
				}
				case 9: {
					break;
				}
				case 10: {
					break;
				}
				case 11: {
					break;
				}
				case 12: {
					break;
				}
				case 13: {
					break;
				}
				case 14: {
					break;
				}
				case 27: {
					break;
				}
				case 28: {
					break;
				}
				case 15: {
					break;
				}
				case 29: {
					break;
				}
				case 30: {
					break;
				}
				case 31: {
					break;
				}
				case 32: {
					break;
				}
				case 33: {
					break;
				}
				case 16: {
					break;
				}
				case 17: {
					break;
				}
				case 18: {
					break;
				}
				case 19: {
					break;
				}
				case 20: {
					break;
				}
				case 21: {
					break;
				}
				case 34: {
					break;
				}
				case 35: {
					break;
				}
				case 36: {
					break;
				}
				case 37: {
					break;
				}
				case 38: {
					break;
				}
				case 39: {
					break;
				}
				case 40: {
					break;
				}
				case 41: {
					break;
				}
				case 42: {
					break;
				}
				case 43: {
					break;
				}
				case 44: {
					break;
				}
				case 45: {
					break;
				}
				case 46: {
					break;
				}
				case 47: {
					break;
				}
				case 48: {
					break;
				}
				case 49: {
					break;
				}
				case 22: {
					break;
				}
				case 50: {
					break;
				}
			}
			switch ( cs ) {
			}
			switch ( cs ) {
				case 1:
				goto _st1;case 0:
				goto _st0;case 23:
				goto _ctr62;case 2:
				goto _st2;case 3:
				goto _st3;case 4:
				goto _st4;case 5:
				goto _st5;case 24:
				goto _ctr65;case 25:
				goto _st25;case 6:
				goto _st6;case 7:
				goto _st7;case 8:
				goto _st8;case 26:
				goto _ctr70;case 9:
				goto _st9;case 10:
				goto _st10;case 11:
				goto _st11;case 12:
				goto _st12;case 13:
				goto _st13;case 14:
				goto _st14;case 27:
				goto _ctr72;case 28:
				goto _st28;case 15:
				goto _st15;case 29:
				goto _st29;case 30:
				goto _ctr78;case 31:
				goto _st31;case 32:
				goto _ctr83;case 33:
				goto _st33;case 16:
				goto _st16;case 17:
				goto _st17;case 18:
				goto _st18;case 19:
				goto _st19;case 20:
				goto _st20;case 21:
				goto _st21;case 34:
				goto _ctr87;case 35:
				goto _ctr89;case 36:
				goto _ctr91;case 37:
				goto _ctr93;case 38:
				goto _ctr95;case 39:
				goto _ctr97;case 40:
				goto _ctr99;case 41:
				goto _ctr101;case 42:
				goto _ctr103;case 43:
				goto _ctr105;case 44:
				goto _ctr107;case 45:
				goto _ctr109;case 46:
				goto _ctr111;case 47:
				goto _ctr113;case 48:
				goto _ctr115;case 49:
				goto _ctr117;case 22:
				goto _st22;case 50:
				goto _st50;	}
		}
		
		if ( cs >= 23 )
			goto _out; _pop: {}
		_out: {}
	}
	
#line 118 "/builddir/build/BUILD/rspamd-2.2/src/ragel/content_disposition_parser.rl"
	
	
	if (st_storage.data) {
		free (st_storage.data);
	}
	
	return cd->type != RSPAMD_CT_UNKNOWN;
}
